/*
 * Copyright 2006-2007, Thomas Maier-Komor
 * LICENSE: GPLv2, see file COPYING for details
 */

#ifndef FSSTATS_H
#define FSSTATS_H

#include <sys/time.h>

#ifndef __sun
typedef unsigned long long hrtime_t;
#endif

typedef struct fsstat_s {
	unsigned long long free, blocks;
	unsigned long fsid;
	hrtime_t ts, rate_ts;
	double read_rate, write_rate, ops_rate;
	char *dev, *mnt;
	char typ[8];
	unsigned long long
		naccess, naddmap, nclose, ncmp, ncreate, ndelmap,
		ndispose, ndump, ndumpctl, nfid, nfrlock, nfsync,
		ngetattr, ngetpage, ngetsecattr, ninactive, nioctl,
		nlink, nlookup, nmap, nmkdir, nopen, npageio, npathconf,
		npoll, nputpage, nread, nreaddir, nreadlink, nrealvp,
		nremove, nrename, nrmdir, nrwlock, nrwunlock, nseek,
		nsetattr, nsetfl, nsetsecattr, nshrlock, nspace,
		nsymlink, nvnevent, nwrite,
		ntotal, numread, numreaddir, numwrite;
	struct fsstat_s *zroot, *next;
} fsstat_t;

extern unsigned long long FsFree, FsSize, Zsize, Zfree;
extern unsigned long Zpools;
extern unsigned NumFs;

extern fsstat_t *get_fs_stats(void);
extern int update_fs_stats(void);
extern void init_zfs(void);

#endif
